diff --git a/roms/ipxe/src/usr/nslookup.c b/roms/ipxe/src/usr/nslookup.c
new file mode 100644
index 0000000000000000000000000000000000000000..c931ec5a1e31d7c323265f5854f2f1c5d0acfe95
--- /dev/null
+++ b/roms/ipxe/src/usr/nslookup.c
@@ -0,0 +1,185 @@
+/*
+ * Copyright (C) 2012 Patrick Plenefisch <phplenefisch@wpi.edu>.
+ *
+ * This program is free software; you can redistribute it and/or
+ * modify it under the terms of the GNU General Public License as
+ * published by the Free Software Foundation; either version 2 of the
+ * License, or any later version.
+ *
+ * This program is distributed in the hope that it will be useful, but
+ * WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
+ * General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
+ */
+
+FILE_LICENCE ( GPL2_OR_LATER );
+
+#include <stdlib.h>
+#include <stdio.h>
+#include <string.h>
+#include <errno.h>
+#include <ipxe/resolv.h>
+#include <ipxe/tcpip.h>
+#include <ipxe/monojob.h>
+#include <ipxe/settings.h>
+#include <usr/nslookup.h>
+
+/** @file
+ *
+ * Standalone name resolution
+ *
+ */
+
+/** A name resolution request */
+struct nslookup {
+	/** Reference count for this object */
+	struct refcnt refcnt;
+
+	/** Job control interface */
+	struct interface job;
+	/** Data transfer interface */
+	struct interface resolver;
+
+	/** Setting name */
+	const char *setting_name;
+};
+
+/**
+ * Terminate name resolution
+ *
+ * @v nslookup		Name resolution request
+ * @v rc		Reason for termination
+ */
+static void nslookup_close ( struct nslookup *nslookup, int rc ) {
+
+	/* Shut down interfaces */
+	intf_shutdown ( &nslookup->resolver, rc );
+	intf_shutdown ( &nslookup->job, rc );
+}
+
+/**
+ * Handle resolved name
+ *
+ * @v nslookup		Name resolution request
+ * @v sa		Completed socket address
+ */
+static void nslookup_resolv_done ( struct nslookup *nslookup,
+				   struct sockaddr *sa ) {
+	struct sockaddr_in *sin;
+	struct setting_type *type;
+	void *data;
+	size_t len;
+	int rc;
+
+	/* Extract address */
+	switch ( sa->sa_family ) {
+	case AF_INET:
+		sin = ( ( struct sockaddr_in * ) sa );
+		data = &sin->sin_addr;
+		len = sizeof ( sin->sin_addr );
+		type = &setting_type_ipv4;
+		break;
+	default:
+		rc = -ENOTSUP;
+		goto err;
+	}
+
+	/* Save in specified setting */
+	if ( ( rc = store_named_setting ( nslookup->setting_name, type,
+					  data, len ) ) != 0 )
+		goto err;
+
+ err:
+	/* Terminate name resolution */
+	nslookup_close ( nslookup, rc );
+}
+
+/** Name resolution resolver interface operations */
+static struct interface_operation nslookup_resolver_operations[] = {
+	INTF_OP ( resolv_done, struct nslookup *, nslookup_resolv_done ),
+	INTF_OP ( intf_close, struct nslookup *, nslookup_close ),
+};
+
+/** Name resolution resolver interface descriptor */
+static struct interface_descriptor nslookup_resolver_desc =
+	INTF_DESC_PASSTHRU ( struct nslookup, resolver,
+			     nslookup_resolver_operations, job );
+
+/** Name resolution job control interface operations */
+static struct interface_operation nslookup_job_operations[] = {
+	INTF_OP ( intf_close, struct nslookup *, nslookup_close ),
+};
+
+/** Name resolution job control interface descriptor */
+static struct interface_descriptor nslookup_job_desc =
+	INTF_DESC_PASSTHRU ( struct nslookup, job,
+			     nslookup_job_operations, resolver );
+
+/**
+ * Initiate standalone name resolution
+ *
+ * @v job		Parent interface
+ * @v name		Name to resolve
+ * @v setting_name	Setting name
+ * @ret rc		Return status code
+ */
+static int resolv_setting ( struct interface *job, const char *name,
+			    const char *setting_name ) {
+	struct nslookup *nslookup;
+	struct sockaddr sa;
+	char *setting_name_copy;
+	int rc;
+
+	/* Allocate and initialise structure */
+	nslookup = zalloc ( sizeof ( *nslookup ) + strlen ( setting_name )
+			    + 1 /* NUL */ );
+	if ( ! nslookup )
+		return -ENOMEM;
+	ref_init ( &nslookup->refcnt, NULL );
+	intf_init ( &nslookup->job, &nslookup_job_desc, &nslookup->refcnt );
+	intf_init ( &nslookup->resolver, &nslookup_resolver_desc,
+		    &nslookup->refcnt );
+	setting_name_copy = ( ( void * ) ( nslookup + 1 ) );
+	strcpy ( setting_name_copy, setting_name );
+	nslookup->setting_name = setting_name_copy;
+
+	/* Start name resolution */
+	memset ( &sa, 0, sizeof ( sa ) );
+	if ( ( rc = resolv ( &nslookup->resolver, name, &sa ) ) != 0 )
+		goto err_resolv;
+
+	/* Attach parent interface, mortalise self, and return */
+	intf_plug_plug ( &nslookup->job, job );
+	ref_put ( &nslookup->refcnt );
+	return 0;
+
+ err_resolv:
+	ref_put ( &nslookup->refcnt );
+	return rc;
+}
+
+/**
+ * Perform (blocking) standalone name resolution
+ *
+ * @v name		Name to resolve
+ * @v setting_name	Setting name
+ * @ret rc		Return status code
+ */
+int nslookup ( const char *name, const char *setting_name ) {
+	int rc;
+
+	/* Perform name resolution */
+	if ( ( rc = resolv_setting ( &monojob, name, setting_name ) ) == 0 )
+		rc = monojob_wait ( NULL );
+	if ( rc != 0 ) {
+		printf ( "Could not resolve %s: %s\n", name, strerror ( rc ) );
+		return rc;
+	}
+
+	return 0;
+}
diff --git a/roms/ipxe/src/usr/prompt.c b/roms/ipxe/src/usr/prompt.c
index 3c353a686a5fa8d1ea8bfe388c3d..ede037457185f0039d450bdb41f5 100644
--- a/roms/ipxe/src/usr/prompt.c
+++ b/roms/ipxe/src/usr/prompt.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/usr/pxemenu.c b/roms/ipxe/src/usr/pxemenu.c
index 75789e2dcde52bf389bf4bfc1214..d50ee6ba917870ae10fc8e479a52 100644
--- a/roms/ipxe/src/usr/pxemenu.c
+++ b/roms/ipxe/src/usr/pxemenu.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
@@ -377,7 +378,7 @@ int pxe_menu_boot ( struct net_device *netdev ) {
 		return -ENOMEM;
 
 	/* Attempt boot */
-	rc = uriboot ( uri, NULL );
+	rc = uriboot ( uri, NULL, 0, URIBOOT_NO_SAN );
 	uri_put ( uri );
 	return rc;
 }
diff --git a/roms/ipxe/src/usr/route.c b/roms/ipxe/src/usr/route.c
index 1da7135bc5150ec8d951516bda13..e393e38d4fade20f9a746d3cfc36 100644
--- a/roms/ipxe/src/usr/route.c
+++ b/roms/ipxe/src/usr/route.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 FILE_LICENCE ( GPL2_OR_LATER );
diff --git a/roms/ipxe/src/util/Makefile b/roms/ipxe/src/util/Makefile
index d72661e21c04b4218acc84435d3f..4a6a7c7c6e3a58d0e271044b686a 100644
--- a/roms/ipxe/src/util/Makefile
+++ b/roms/ipxe/src/util/Makefile
@@ -1,17 +1,11 @@
 BLIB = ../bin/blib.a
 CFLAGS = -Os
 
-all : hijack prototester mucurses_test
+all : hijack mucurses_test
 
 hijack : hijack.c
 	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -Wall -lpcap -o $@ $<
 
-prototester.o : prototester.c
-	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -Wall -o $@ -c $< -idirafter ../include
-
-prototester : prototester.o $(BLIB)
-	$(CC) -o $@ $< -lc $(BLIB)
-
 mucurses_test.o : mucurses_test.c
 	$(CC) $(CFLAGS) $(EXTRA_CFLAGS) -Wall -o $@ -c $<
 
@@ -19,4 +13,4 @@ mucurses_test : mucurses_test.o $(BLIB)
 	$(CC) -o $@ $< -lc $(BLIB)
 
 clean :
-	rm -f hijack prototester mucurses_test *.o
+	rm -f hijack mucurses_test *.o
diff --git a/roms/ipxe/src/util/Option/ROM.pm b/roms/ipxe/src/util/Option/ROM.pm
index 9fea4d344eab786d31985045985a..fb37ce4b0cc4e27528afc4044143 100644
--- a/roms/ipxe/src/util/Option/ROM.pm
+++ b/roms/ipxe/src/util/Option/ROM.pm
@@ -14,7 +14,8 @@ package Option::ROM;
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 =head1 NAME
 
@@ -169,13 +170,17 @@ use Exporter 'import';
 
 use constant ROM_SIGNATURE => 0xaa55;
 use constant PCI_SIGNATURE => 'PCIR';
+use constant PCI_LAST_IMAGE => 0x80;
 use constant PNP_SIGNATURE => '$PnP';
+use constant IPXE_SIGNATURE => 'iPXE';
 
-our @EXPORT_OK = qw ( ROM_SIGNATURE PCI_SIGNATURE PNP_SIGNATURE );
+our @EXPORT_OK = qw ( ROM_SIGNATURE PCI_SIGNATURE PCI_LAST_IMAGE
+		      PNP_SIGNATURE IPXE_SIGNATURE );
 our %EXPORT_TAGS = ( all => [ @EXPORT_OK ] );
 
 use constant JMP_SHORT => 0xeb;
 use constant JMP_NEAR => 0xe9;
+use constant CALL_NEAR => 0xe8;
 
 sub pack_init {
   my $dest = shift;
@@ -199,6 +204,9 @@ sub unpack_init {
   } elsif ( $jump == JMP_NEAR ) {
     my $offset = unpack ( "xS", $instr );
     return ( $offset + 6 );
+  } elsif ( $jump == CALL_NEAR ) {
+    my $offset = unpack ( "xS", $instr );
+    return ( $offset + 6 );
   } elsif ( $jump == 0 ) {
     return 0;
   } else {
@@ -229,6 +237,7 @@ sub new {
       init =>		{ offset => 0x03, length => 0x03,
 			  pack => \&pack_init, unpack => \&unpack_init },
       checksum =>	{ offset => 0x06, length => 0x01, pack => "C" },
+      ipxe_header =>	{ offset => 0x10, length => 0x02, pack => "S" },
       bofm_header =>	{ offset => 0x14, length => 0x02, pack => "S" },
       undi_header =>	{ offset => 0x16, length => 0x02, pack => "S" },
       pci_header =>	{ offset => 0x18, length => 0x02, pack => "S" },
@@ -241,6 +250,53 @@ sub new {
 
 =pod
 
+=item C<< set ( $data ) >>
+
+Set option ROM contents.
+
+=cut
+
+sub set {
+  my $hash = shift;
+  my $self = tied(%$hash);
+  my $data = shift;
+
+  # Store data
+  $self->{data} = \$data;
+
+  # Split out any data belonging to the next image
+  delete $self->{next_image};
+  my $length = ( $hash->{length} * 512 );
+  my $pci_header = $hash->pci_header();
+  if ( ( $length < length $data ) &&
+       ( defined $pci_header ) &&
+       ( ! ( $pci_header->{last_image} & PCI_LAST_IMAGE ) ) ) {
+    my $remainder = substr ( $data, $length );
+    $data = substr ( $data, 0, $length );
+    $self->{next_image} = new Option::ROM;
+    $self->{next_image}->set ( $remainder );
+  }
+}
+
+=pod
+
+=item C<< get () >>
+
+Get option ROM contents.
+
+=cut
+
+sub get {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  my $data = ${$self->{data}};
+  $data .= $self->{next_image}->get() if $self->{next_image};
+  return $data;
+}
+
+=pod
+
 =item C<< load ( $filename ) >>
 
 Load option ROM contents from the file C<$filename>.
@@ -256,8 +312,8 @@ sub load {
 
   open my $fh, "<$filename"
       or croak "Cannot open $filename for reading: $!";
-  read $fh, my $data, ( 128 * 1024 ); # 128kB is theoretical max size
-  $self->{data} = \$data;
+  read $fh, my $data, -s $fh;
+  $hash->set ( $data );
   close $fh;
 }
 
@@ -279,7 +335,8 @@ sub save {
 
   open my $fh, ">$filename"
       or croak "Cannot open $filename for writing: $!";
-  print $fh ${$self->{data}};
+  my $data = $hash->get();
+  print $fh $data;
   close $fh;
 }
 
@@ -339,6 +396,60 @@ sub pnp_header {
 
 =pod
 
+=item C<< undi_header () >>
+
+Return a C<Option::ROM::UNDI> object representing the ROM's UNDI header,
+if present.
+
+=cut
+
+sub undi_header {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  my $offset = $hash->{undi_header};
+  return undef unless $offset != 0;
+
+  return Option::ROM::UNDI->new ( $self->{data}, $offset );
+}
+
+=pod
+
+=item C<< ipxe_header () >>
+
+Return a C<Option::ROM::iPXE> object representing the ROM's iPXE
+header, if present.
+
+=cut
+
+sub ipxe_header {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  my $offset = $hash->{ipxe_header};
+  return undef unless $offset != 0;
+
+  return Option::ROM::iPXE->new ( $self->{data}, $offset );
+}
+
+=pod
+
+=item C<< next_image () >>
+
+Return a C<Option::ROM> object representing the next image within the
+ROM, if present.
+
+=cut
+
+sub next_image {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  return $self->{next_image};
+}
+
+=pod
+
 =item C<< checksum () >>
 
 Calculate the byte checksum of the ROM.
@@ -499,4 +610,119 @@ sub product {
   return unpack ( "Z*", $raw );
 }
 
+##############################################################################
+#
+# Option::ROM::UNDI
+#
+##############################################################################
+
+package Option::ROM::UNDI;
+
+use strict;
+use warnings;
+use Carp;
+use bytes;
+
+sub new {
+  my $class = shift;
+  my $data = shift;
+  my $offset = shift;
+
+  my $hash = {};
+  tie %$hash, "Option::ROM::Fields", {
+    data => $data,
+    offset => $offset,
+    length => 0x16,
+    fields => {
+      signature =>	{ offset => 0x00, length => 0x04, pack => "a4" },
+      struct_length =>	{ offset => 0x04, length => 0x01, pack => "C" },
+      checksum =>	{ offset => 0x05, length => 0x01, pack => "C" },
+      struct_revision =>{ offset => 0x06, length => 0x01, pack => "C" },
+      version_revision =>{ offset => 0x07, length => 0x01, pack => "C" },
+      version_minor =>	{ offset => 0x08, length => 0x01, pack => "C" },
+      version_major =>	{ offset => 0x09, length => 0x01, pack => "C" },
+      loader_entry =>	{ offset => 0x0a, length => 0x02, pack => "S" },
+      stack_size =>	{ offset => 0x0c, length => 0x02, pack => "S" },
+      data_size =>	{ offset => 0x0e, length => 0x02, pack => "S" },
+      code_size =>	{ offset => 0x10, length => 0x02, pack => "S" },
+      bus_type =>	{ offset => 0x12, length => 0x04, pack => "a4" },
+    },
+  };
+  bless $hash, $class;
+
+  # Retrieve true length of structure
+  my $self = tied ( %$hash );
+  $self->{length} = $hash->{struct_length};
+
+  return $hash;
+}
+
+sub checksum {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  return $self->checksum();
+}
+
+sub fix_checksum {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  $hash->{checksum} = ( ( $hash->{checksum} - $hash->checksum() ) & 0xff );
+}
+
+##############################################################################
+#
+# Option::ROM::iPXE
+#
+##############################################################################
+
+package Option::ROM::iPXE;
+
+use strict;
+use warnings;
+use Carp;
+use bytes;
+
+sub new {
+  my $class = shift;
+  my $data = shift;
+  my $offset = shift;
+
+  my $hash = {};
+  tie %$hash, "Option::ROM::Fields", {
+    data => $data,
+    offset => $offset,
+    length => 0x06,
+    fields => {
+      signature =>	{ offset => 0x00, length => 0x04, pack => "a4" },
+      struct_length =>	{ offset => 0x04, length => 0x01, pack => "C" },
+      checksum =>	{ offset => 0x05, length => 0x01, pack => "C" },
+      shrunk_length =>	{ offset => 0x06, length => 0x01, pack => "C" },
+      build_id =>	{ offset => 0x08, length => 0x04, pack => "L" },
+    },
+  };
+  bless $hash, $class;
+
+  # Retrieve true length of structure
+  my $self = tied ( %$hash );
+  $self->{length} = $hash->{struct_length};
+
+  return $hash;
+}
+
+sub checksum {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  return $self->checksum();
+}
+
+sub fix_checksum {
+  my $hash = shift;
+  my $self = tied(%$hash);
+
+  $hash->{checksum} = ( ( $hash->{checksum} - $hash->checksum() ) & 0xff );
+}
+
 1;
diff --git a/roms/ipxe/src/util/catrom.pl b/roms/ipxe/src/util/catrom.pl
index fe37e6b6e81ae1e56e279fed55d4..da99d7b9708cebca8c600f61fea7 100755
--- a/roms/ipxe/src/util/catrom.pl
+++ b/roms/ipxe/src/util/catrom.pl
@@ -3,46 +3,27 @@
 use warnings;
 use strict;
 
-use bytes;
+use FindBin;
+use lib "$FindBin::Bin";
+use Option::ROM qw ( :all );
 
-use constant MAX_ROM_LEN => 1024*1024;
-use constant PCI_OFF => 0x18;
-use constant INDICATOR_OFF => 0x15;
-
-my $total_len = 0;
 my @romfiles = @ARGV
     or die "Usage: $0 rom-file-1 rom-file-2 ... > multi-rom-file\n";
 
 while ( my $romfile = shift @romfiles ) {
-  my $last = @romfiles ? 0 : 1;
-
-  open ROM, "<$romfile" or die "Could not open $romfile: $!\n";
-  my $len = read ( ROM, my $romdata, MAX_ROM_LEN )
-      or die "Could not read $romfile: $!\n";
-  close ROM;
-
-  die "$romfile is not a ROM file\n"
-      unless substr ( $romdata, 0, 2 ) eq "\x55\xAA";
 
-  ( my $checklen ) = unpack ( 'C', substr ( $romdata, 2, 1 ) );
-  $checklen *= 512;
-  die "$romfile has incorrect length field $checklen (should be $len)\n"
-      unless $len == $checklen;
+  # Read ROM file
+  my $rom = new Option::ROM;
+  $rom->load ( $romfile );
 
-  ( my $pci ) = unpack ( 'v', substr ( $romdata, PCI_OFF, 2 ) );
-  die "Invalid PCI offset field in $romfile\n"
-      if $pci >= $len;
-  die "No PCIR signature in $romfile\n"
-      unless substr ( $romdata, $pci, 4 ) eq "PCIR";
-  
-  ( my $indicator ) =
-      unpack ( 'C', substr ( $romdata, $pci + INDICATOR_OFF, 1 ) );
-  my $msg = sprintf ( "$romfile: indicator was %02x, ", $indicator );
-  $indicator &= ! ( 1 << 7 );
-  $indicator |= ( $last << 7 );
-  $msg .= sprintf ( "now %02x\n", $indicator );
-  substr ( $romdata, $pci + INDICATOR_OFF, 1 ) = pack ( 'C', $indicator );
-  warn $msg;
+  # Tag final image as non-final in all except the final ROM
+  if ( @romfiles ) {
+    my $image = $rom;
+    $image = $image->next_image() while $image->next_image();
+    $image->pci_header->{last_image} &= ~PCI_LAST_IMAGE;
+    $image->fix_checksum();
+  }
 
-  print $romdata;
+  # Write ROM file to STDOUT
+  $rom->save ( "-" );
 }
diff --git a/roms/ipxe/src/util/disrom.pl b/roms/ipxe/src/util/disrom.pl
index 1fb4cc3cb80daeb382c13e098c18..574957acda8cce1b702459e1c460 100755
--- a/roms/ipxe/src/util/disrom.pl
+++ b/roms/ipxe/src/util/disrom.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 use strict;
 use warnings;
@@ -27,55 +28,88 @@ my $romfile = shift || "-";
 my $rom = new Option::ROM;
 $rom->load ( $romfile );
 
-die "Not an option ROM image\n"
-    unless $rom->{signature} == ROM_SIGNATURE;
+do {
 
-my $romlength = ( $rom->{length} * 512 );
-my $filelength = $rom->length;
-die "ROM image truncated (is $filelength, should be $romlength)\n"
-    if $filelength < $romlength;
+  die "Not an option ROM image\n"
+      unless $rom->{signature} == ROM_SIGNATURE;
 
-printf "ROM header:\n\n";
-printf "  %-16s 0x%02x (%d)\n", "Length:", $rom->{length}, ( $rom->{length} * 512 );
-printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $rom->{checksum},
-       ( ( $rom->checksum == 0 ) ? "" : "INCORRECT: " ), $rom->checksum;
-printf "  %-16s 0x%04x\n", "Init:", $rom->{init};
-printf "  %-16s 0x%04x\n", "UNDI header:", $rom->{undi_header};
-printf "  %-16s 0x%04x\n", "PCI header:", $rom->{pci_header};
-printf "  %-16s 0x%04x\n", "PnP header:", $rom->{pnp_header};
-printf "\n";
+  my $romlength = ( $rom->{length} * 512 );
+  my $filelength = $rom->length;
+  die "ROM image truncated (is $filelength, should be $romlength)\n"
+      if $filelength < $romlength;
 
-my $pci = $rom->pci_header();
-if ( $pci ) {
-  printf "PCI header:\n\n";
-  printf "  %-16s %s\n", "Signature:", $pci->{signature};
-  printf "  %-16s 0x%04x\n", "Vendor ID:", $pci->{vendor_id};
-  printf "  %-16s 0x%04x\n", "Device ID:", $pci->{device_id};
-  printf "  %-16s 0x%02x%02x%02x\n", "Device class:",
-	 $pci->{base_class}, $pci->{sub_class}, $pci->{prog_intf};
-  printf "  %-16s 0x%04x (%d)\n", "Image length:",
-	 $pci->{image_length}, ( $pci->{image_length} * 512 );
-  printf "  %-16s 0x%04x (%d)\n", "Runtime length:",
-	 $pci->{runtime_length}, ( $pci->{runtime_length} * 512 );
-  if ( exists $pci->{conf_header} ) {
-    printf "  %-16s 0x%04x\n", "Config header:", $pci->{conf_header};
-    printf "  %-16s 0x%04x\n", "CLP entry:", $pci->{clp_entry};
-  }
+  printf "ROM header:\n\n";
+  printf "  %-16s 0x%02x (%d)\n", "Length:",
+	 $rom->{length}, ( $rom->{length} * 512 );
+  printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $rom->{checksum},
+	 ( ( $rom->checksum == 0 ) ? "" : "INCORRECT: " ), $rom->checksum;
+  printf "  %-16s 0x%04x\n", "Init:", $rom->{init};
+  printf "  %-16s 0x%04x\n", "UNDI header:", $rom->{undi_header};
+  printf "  %-16s 0x%04x\n", "PCI header:", $rom->{pci_header};
+  printf "  %-16s 0x%04x\n", "PnP header:", $rom->{pnp_header};
   printf "\n";
-}
 
-my $pnp = $rom->pnp_header();
-if ( $pnp ) {
-  printf "PnP header:\n\n";
-  printf "  %-16s %s\n", "Signature:", $pnp->{signature};
-  printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $pnp->{checksum},
-	 ( ( $pnp->checksum == 0 ) ? "" : "INCORRECT: " ), $pnp->checksum;
-  printf "  %-16s 0x%04x \"%s\"\n", "Manufacturer:",
-	 $pnp->{manufacturer}, $pnp->manufacturer;
-  printf "  %-16s 0x%04x \"%s\"\n", "Product:",
-	 $pnp->{product}, $pnp->product;
-  printf "  %-16s 0x%04x\n", "BCV:", $pnp->{bcv};
-  printf "  %-16s 0x%04x\n", "BDV:", $pnp->{bdv};
-  printf "  %-16s 0x%04x\n", "BEV:", $pnp->{bev};
-  printf "\n";
-}
+  my $pci = $rom->pci_header();
+  if ( $pci ) {
+    printf "PCI header:\n\n";
+    printf "  %-16s %s\n", "Signature:", $pci->{signature};
+    printf "  %-16s 0x%04x\n", "Vendor ID:", $pci->{vendor_id};
+    printf "  %-16s 0x%04x\n", "Device ID:", $pci->{device_id};
+    printf "  %-16s 0x%02x%02x%02x\n", "Device class:",
+	   $pci->{base_class}, $pci->{sub_class}, $pci->{prog_intf};
+    printf "  %-16s 0x%04x (%d)\n", "Image length:",
+	   $pci->{image_length}, ( $pci->{image_length} * 512 );
+    printf "  %-16s 0x%04x (%d)\n", "Runtime length:",
+	   $pci->{runtime_length}, ( $pci->{runtime_length} * 512 );
+    printf "  %-16s 0x%02x\n", "Code type:", $pci->{code_type};
+    if ( exists $pci->{conf_header} ) {
+      printf "  %-16s 0x%04x\n", "Config header:", $pci->{conf_header};
+      printf "  %-16s 0x%04x\n", "CLP entry:", $pci->{clp_entry};
+    }
+    printf "\n";
+  }
+
+  my $pnp = $rom->pnp_header();
+  if ( $pnp ) {
+    printf "PnP header:\n\n";
+    printf "  %-16s %s\n", "Signature:", $pnp->{signature};
+    printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $pnp->{checksum},
+	   ( ( $pnp->checksum == 0 ) ? "" : "INCORRECT: " ), $pnp->checksum;
+    printf "  %-16s 0x%04x \"%s\"\n", "Manufacturer:",
+	   $pnp->{manufacturer}, $pnp->manufacturer;
+    printf "  %-16s 0x%04x \"%s\"\n", "Product:",
+	   $pnp->{product}, $pnp->product;
+    printf "  %-16s 0x%04x\n", "BCV:", $pnp->{bcv};
+    printf "  %-16s 0x%04x\n", "BDV:", $pnp->{bdv};
+    printf "  %-16s 0x%04x\n", "BEV:", $pnp->{bev};
+    printf "\n";
+  }
+
+  my $undi = $rom->undi_header();
+  if ( $undi ) {
+    printf "UNDI header:\n\n";
+    printf "  %-16s %s\n", "Signature:", $undi->{signature};
+    printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $undi->{checksum},
+	   ( ( $undi->checksum == 0 ) ? "" : "INCORRECT: " ), $undi->checksum;
+    printf "  %-16s %d.%d.%d\n", "UNDI version:", $undi->{version_major},
+	   $undi->{version_minor}, $undi->{version_revision};
+    printf "  %-16s 0x%04x\n", "Loader entry:", $undi->{loader_entry};
+    printf "  %-16s 0x%04x\n", "Stack size:", $undi->{stack_size};
+    printf "  %-16s 0x%04x\n", "Data size:", $undi->{data_size};
+    printf "  %-16s 0x%04x\n", "Code size:", $undi->{code_size};
+    printf "  %-16s %s\n", "Bus type:", $undi->{bus_type};
+    printf "\n";
+  }
+
+  my $ipxe = $rom->ipxe_header();
+  if ( $ipxe ) {
+    printf "iPXE header:\n\n";
+    printf "  %-16s 0x%02x (%s0x%02x)\n", "Checksum:", $ipxe->{checksum},
+	   ( ( $ipxe->checksum == 0 ) ? "" : "INCORRECT: " ), $ipxe->checksum;
+    printf "  %-16s 0x%02x (%d)\n", "Shrunk length:",
+	   $ipxe->{shrunk_length}, ( $ipxe->{shrunk_length} * 512 );
+    printf "  %-16s 0x%08x\n", "Build ID:", $ipxe->{build_id};
+    printf "\n";
+  }
+
+} while ( $rom = $rom->next_image );
diff --git a/roms/ipxe/src/util/efirom.c b/roms/ipxe/src/util/efirom.c
index d0bdace62df9f664451ea99c0433..abee496dd0d7fd6441612366234b 100644
--- a/roms/ipxe/src/util/efirom.c
+++ b/roms/ipxe/src/util/efirom.c
@@ -13,7 +13,8 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #include <stdint.h>
@@ -56,18 +57,6 @@ static void * xmalloc ( size_t len ) {
 	return ptr;
 }
 
-/**
- * Get file size
- *
- * @v file		File
- * @v len		File size
- */
-static size_t file_size ( FILE *file ) {
-	ssize_t len;
-
-	return len;
-}
-
 /**
  * Read information from PE headers
  *
@@ -239,15 +228,15 @@ static int parse_options ( const int argc, char **argv,
 }
 
 int main ( int argc, char **argv ) {
-	struct options opts = {
-	};
-	unsigned int infile_index;
+	struct options opts;
+	int infile_index;
 	const char *infile_name;
 	const char *outfile_name;
 	FILE *infile;
 	FILE *outfile;
 
 	/* Parse command-line arguments */
+	memset ( &opts, 0, sizeof ( opts ) );
 	infile_index = parse_options ( argc, argv, &opts );
 	if ( argc != ( infile_index + 2 ) ) {
 		print_help ( argv[0] );
diff --git a/roms/ipxe/src/util/einfo.c b/roms/ipxe/src/util/einfo.c
index 06736f219abe8ef56a6f0e206ec5..354d475fa2b46aa5806f8d3b39e4 100644
--- a/roms/ipxe/src/util/einfo.c
+++ b/roms/ipxe/src/util/einfo.c
@@ -13,13 +13,15 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #include <stddef.h>
 #include <stdint.h>
 #include <stdlib.h>
 #include <stdio.h>
+#include <string.h>
 #include <errno.h>
 #include <sys/types.h>
 #include <sys/stat.h>
@@ -49,7 +51,8 @@ struct einfo {
  * @v infile		Filename
  * @v opts		Command-line options
  */
-static void einfo ( const char *infile, struct options *opts ) {
+static void einfo ( const char *infile,
+		    struct options *opts __attribute__ (( unused )) ) {
 	int fd;
 	struct stat stat;
 	size_t len;
@@ -85,15 +88,16 @@ static void einfo ( const char *infile, struct options *opts ) {
 		for ( einfo = start ; ( ( void * ) einfo ) < ( start + len ) ;
 		      einfo = ( ( ( void * ) einfo ) + einfo->size ) ) {
 			printf ( "%08x\t%s\t%d\t%s\n", einfo->error,
-				 ( ( ( void * ) einfo ) + einfo->file ),
+				 ( ( ( char * ) einfo ) + einfo->file ),
 				 einfo->line,
-				 ( ( ( void * ) einfo ) + einfo->desc ) );
+				 ( ( ( char * ) einfo ) + einfo->desc ) );
 		}
 
+		/* Unmap file */
+		munmap ( start, len );
 	}
 
-	/* Unmap and close file */
-	munmap ( start, len );
+	/* Close file */
 	close ( fd );
 }
 
@@ -115,8 +119,7 @@ static void print_help ( const char *program_name ) {
  * @v opts		Options structure to populate
  */
 static int parse_options ( const int argc, char **argv,
-			   struct options *opts ) {
-	char *end;
+			   struct options *opts __attribute__ (( unused )) ) {
 	int c;
 
 	while (1) {
@@ -147,7 +150,7 @@ static int parse_options ( const int argc, char **argv,
 int main ( int argc, char **argv ) {
 	struct options opts = {
 	};
-	unsigned int infile_index;
+	int infile_index;
 	const char *infile;
 
 	/* Parse command-line arguments */
diff --git a/roms/ipxe/src/util/elf2efi.c b/roms/ipxe/src/util/elf2efi.c
index e66292966d3eed7c5baee0ffdc03..45d539574e3be734958f7af38ab1 100644
--- a/roms/ipxe/src/util/elf2efi.c
+++ b/roms/ipxe/src/util/elf2efi.c
@@ -13,10 +13,13 @@
  *
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
- * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+ * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+ * 02110-1301, USA.
  */
 
 #define _GNU_SOURCE
+#define PACKAGE "elf2efi"
+#define PACKAGE_VERSION "1"
 #include <stdint.h>
 #include <stddef.h>
 #include <stdlib.h>
@@ -405,6 +408,10 @@ static struct pe_section * process_section ( bfd *bfd,
 			  EFI_IMAGE_SCN_MEM_WRITE );
 		applicable_start = &data_mid;
 		applicable_end = &data_end;
+	} else {
+		eprintf ( "Unrecognised characteristics %#lx for section %s\n",
+			  flags, section->name );
+		exit ( 1 );
 	}
 
 	/* Copy in section contents */
@@ -459,7 +466,8 @@ static struct pe_section * process_section ( bfd *bfd,
  * @v rel		Relocation entry
  * @v pe_reltab		PE relocation table to fill in
  */
-static void process_reloc ( bfd *bfd, asection *section, arelent *rel,
+static void process_reloc ( bfd *bfd __attribute__ (( unused )),
+			    asection *section, arelent *rel,
 			    struct pe_relocs **pe_reltab ) {
 	reloc_howto_type *howto = rel->howto;
 	asymbol *sym = *(rel->sym_ptr_ptr);
@@ -608,8 +616,11 @@ static void write_pe_file ( struct pe_header *pe_header,
 	struct pe_section *section;
 	unsigned long fpos = 0;
 
+	/* Align length of headers */
+	fpos = pe_header->nt.OptionalHeader.SizeOfHeaders =
+		efi_file_align ( pe_header->nt.OptionalHeader.SizeOfHeaders );
+
 	/* Assign raw data pointers */
-	fpos = efi_file_align ( pe_header->nt.OptionalHeader.SizeOfHeaders );
 	for ( section = pe_sections ; section ; section = section->next ) {
 		if ( section->hdr.SizeOfRawData ) {
 			section->hdr.PointerToRawData = fpos;
@@ -637,7 +648,7 @@ static void write_pe_file ( struct pe_header *pe_header,
 	for ( section = pe_sections ; section ; section = section->next ) {
 		if ( fseek ( pe, section->hdr.PointerToRawData,
 			     SEEK_SET ) != 0 ) {
-			eprintf ( "Could not seek to %lx: %s\n",
+			eprintf ( "Could not seek to %x: %s\n",
 				  section->hdr.PointerToRawData,
 				  strerror ( errno ) );
 			exit ( 1 );
@@ -786,7 +797,7 @@ int main ( int argc, char **argv ) {
 	struct options opts = {
 		.subsystem = EFI_IMAGE_SUBSYSTEM_EFI_APPLICATION,
 	};
-	unsigned int infile_index;
+	int infile_index;
 	const char *infile;
 	const char *outfile;
 
diff --git a/roms/ipxe/src/util/fixrom.pl b/roms/ipxe/src/util/fixrom.pl
index c3a31f41e37cc304f5a84548bd49..dcc38fe4ba831fb0156f751c33ba 100755
--- a/roms/ipxe/src/util/fixrom.pl
+++ b/roms/ipxe/src/util/fixrom.pl
@@ -14,7 +14,8 @@
 #
 # You should have received a copy of the GNU General Public License
 # along with this program; if not, write to the Free Software
-# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
 
 use strict;
 use warnings;
@@ -28,7 +29,13 @@ my @romfiles = @ARGV;
 foreach my $romfile ( @romfiles ) {
   my $rom = new Option::ROM;
   $rom->load ( $romfile );
-  $rom->pnp_header->fix_checksum() if $rom->pnp_header;
-  $rom->fix_checksum();
+  my $image = $rom;
+  while ( $image ) {
+    $image->pnp_header->fix_checksum() if $image->pnp_header;
+    $image->undi_header->fix_checksum() if $image->undi_header;
+    $image->ipxe_header->fix_checksum() if $image->ipxe_header;
+    $image->fix_checksum();
+    $image = $image->next_image();
+  }
   $rom->save ( $romfile );
 }
